import java.lang.*;
import sorter.*;

class Test {
  /**
   * Print the first and last ten elements of the given array.
   */
  public static void printArray(Object[] arrayOfObjects) {
    int i;
    
    for (i = 0; i < Math.min(10, arrayOfObjects.length); i++)
      System.out.print(arrayOfObjects[i] + " ");
    if (i < arrayOfObjects.length) {
      if (arrayOfObjects.length > 20)
        System.out.print("... ");
      for (i = Math.max(arrayOfObjects.length - 10, 10); i < arrayOfObjects.length; i++)
        System.out.print(arrayOfObjects[i] + " ");
    }
    System.out.println();
  }

  public static void main(String[] args) {
    /**
     * Create a sorter for Integers.
     */
    ASorter sorterForIntegers = new QuickSorter(new AOrder() {
      public boolean lt(Object x, Object y) {
        return ((Integer)x < (Integer)y);
      }

      public boolean eq(Object x, Object y) {
        return ((Integer)x == (Integer)y);
      }
    });

    Integer[] arrayOfIntegers = new Integer[10000];
    
    /**
     * Initialize the array of Integers to contain the values
     * from arrayOfIntegers.length to one in descending order.
     */
    for (int i = 0; i < arrayOfIntegers.length; i++)
      arrayOfIntegers[i] = arrayOfIntegers.length - i;
    
    printArray(arrayOfIntegers);
    
    sorterForIntegers.sort(arrayOfIntegers, 0, arrayOfIntegers.length - 1);
  
    printArray(arrayOfIntegers);
  }
}
